// -*- C++ -*-
/*!
 * @file  PublisherFlush.h
 * @brief PublisherFlush class
 * @date  $Date: 2007-12-31 03:08:06 $
 * @author Noriaki Ando <n-ando@aist.go.jp>
 *
 * Copyright (C) 2006-2008
 *     Noriaki Ando
 *     Task-intelligence Research Group,
 *     Intelligent Systems Research Institute,
 *     National Institute of
 *         Advanced Industrial Science and Technology (AIST), Japan
 *     All rights reserved.
 *
 * $Id: PublisherFlush.h 706 2008-04-16 00:36:15Z n-ando $
 *
 */

#ifndef PublisherFlush_h
#define PublisherFlush_h

#include <rtm/PublisherBase.h>

namespace RTC
{
  class InPortConsumer;
  class Properties;
  /*!
   * @if jp
   * @class PublisherFlush
   * @brief PublisherFlush 饹
   *
   * Flush  Publisher 饹
   * Хåե˳ǼƤ̤ǡ롣
   * ǡФԤĥ󥷥塼ޤФ¦Ʊåɤư롣
   *
   * @else
   * @class PublisherFlush
   * @brief PublisherFlush class
   *
   * This is a Publisher class of Flush type.
   * This class sends unsend data that has been stored in the buffer.
   * This executes Consumer that waits for the data send timing in the same 
   * thread as its send side.
   *
   * @endif
   */
  class PublisherFlush
    : public PublisherBase
  {
  public:
    /*!
     * @if jp
     * @brief 󥹥ȥ饯
     *
     * 󥹥ȥ饯
     *
     * @param consumer ǡФԤĥ󥷥塼
     * @param property PublisherζưꤷProperty֥
     *
     * @else
     * @brief Constructor
     *
     * Consrtuctor.
     *
     * @param consumer Consumer to wait for the data sending
     * @param property Property object that have been set the control
     *                 information of this Publisher
     *
     * @endif
     */
    PublisherFlush(InPortConsumer* consumer,
		   const Properties& property);
    
    /*!
     * @if jp
     * @brief ǥȥ饯
     *
     * ǥȥ饯
     * Publisher˴ݤˡPublisherFactoryˤƤӽФ롣
     *
     * @else
     * @brief Destructor
     *
     * Destructor
     * This is invoked by PublisherFactory when this Publisher is destoroyed.
     *
     * @endif
     */
    virtual ~PublisherFlush();
    
    /*!
     * @if jp
     * @brief Observerؿ
     *
     * Хߥ󥰻˸ƤӽФ
     * ¨¤Ʊ쥹åɤˤƥ󥷥塼ޤнƤӽФ롣
     *
     * @else
     * @brief Observer function
     *
     * This is invoked at the send timing.
     * Immediately, the Consumer's sending process is invoked in the same thread.
     *
     * @endif
     */
    virtual void update();
  protected:
    
  private:
    InPortConsumer* m_consumer;
    
  };
};     // namespace RTC
#endif // PublisherFlush_h

